﻿using System;
using System.Runtime.Serialization;
using ThinkGeo.MapSuite.Core;

namespace ThinkGeo.MapSuite.VehicleTracking
{
    /// <summary>
    /// This class specify the basic information for a location.
    /// </summary>
    [DataContract]
    public class Location
    {
        private double speed;
        private double latitude;
        private double longitude;
        private DateTime dateTime;

        public Location()
            : this(0, 0, 0, DateTime.Now)
        { }

        public Location(double longitude, double latitude, double speed, DateTime dateTime)
        {
            Longitude = longitude;
            Latitude = latitude;
            Speed = speed;
            DateTime = dateTime;
        }

        [DataMember]
        public double Longitude
        {
            get { return longitude; }
            set { longitude = value; }
        }

        [DataMember]
        public double Latitude
        {
            get { return latitude; }
            set { latitude = value; }
        }

        [DataMember]
        public double Speed
        {
            get { return speed; }
            set { speed = value; }
        }

        [DataMember]
        public DateTime DateTime
        {
            get { return dateTime; }
            set { dateTime = value; }
        }
    }
}
