﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace ThinkGeo.MapSuite.VehicleTracking
{
    public abstract class TrackingDataProvider : IDisposable
    {
        public abstract Dictionary<int, Vehicle> GetCurrentVehicles(DateTime currentTime);

        public abstract Collection<string> GetSpatialFences();

        public abstract void DeleteSpatialFencesExcluding(IEnumerable<string> excludeFeatureIds);

        public abstract int UpdateSpatialFenceByFeature(string wkt, string featureId);

        public abstract void InsertSpatialFence(string wkt, string featureId);

        public abstract void Dispose();
    }
}