﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.ServiceModel;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.VehicleTracking;

namespace MapSuiteVehicleTracking.Web.Services
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the interface name "ITrackingAccessPrividerSource" in both code and config file together.
    [ServiceContract]
    public interface ITrackingAccessPrividerSource
    {
        [OperationContract]
        void DeleteAndUpdateAndInsertSpatialFences(IEnumerable<string> excludeFeatureWktIds);
        [OperationContract]
        Dictionary<int, Vehicle> GetCurrentVehicles(DateTime currentTime);
        [OperationContract]
        Collection<string> GetSpatialFences();
        [OperationContract]
        void DeleteSpatialFencesExcluding(IEnumerable<string> excludeFeatureIds);
        [OperationContract]
        int UpdateSpatialFenceByFeature(string wkt, string featureId);
        [OperationContract]
        void InsertSpatialFence(string wkt, string featureId);

    }
}
