﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using ThinkGeo.MapSuite.VehicleTracking;

namespace MapSuiteVehicleTracking.Web.Services
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "TrackingAccessPrividerSource" in code, svc and config file together.
    public class TrackingAccessPrividerSource : ITrackingAccessPrividerSource
    {
        public TrackingAccessPrividerSource()
        {
        }

        public void DeleteAndUpdateAndInsertSpatialFences(IEnumerable<string> excludeFeatureWktIds)
        {
            using (TrackingAccessProvider provider = new TrackingAccessProvider(Default.AccessFilePath))
            {
                provider.DeleteAndUpdateAndInsertSpatialFences(excludeFeatureWktIds);
            }
        }

        public Dictionary<int, Vehicle> GetCurrentVehicles(DateTime currentTime)
        {
            using (TrackingAccessProvider provider = new TrackingAccessProvider(Default.AccessFilePath))
            {
                return provider.GetCurrentVehicles(currentTime);
            }
        }

        public Collection<string> GetSpatialFences()
        {
            Collection<string> features;
            using (TrackingAccessProvider provider = new TrackingAccessProvider(Default.AccessFilePath))
            {
                features = provider.GetSpatialFences();
            }
            return features;
        }

        public void DeleteSpatialFencesExcluding(IEnumerable<string> excludeFeatures)
        {
            using (TrackingAccessProvider provider = new TrackingAccessProvider(Default.AccessFilePath))
            {
                provider.DeleteSpatialFencesExcluding(excludeFeatures);
            }
        }

        public int UpdateSpatialFenceByFeature(string wkt, string featureId)
        {
            using (TrackingAccessProvider provider = new TrackingAccessProvider(Default.AccessFilePath))
            {
                return provider.UpdateSpatialFenceByFeature(wkt, featureId);
            }
        }

        public void InsertSpatialFence(string wkt, string featureId)
        {
            using (TrackingAccessProvider provider = new TrackingAccessProvider(Default.AccessFilePath))
            {
                provider.InsertSpatialFence(wkt, featureId);
            }
        }
    }
}
