﻿using System;
using System.Globalization;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows;
using System.Windows.Controls;

namespace ThinkGeo.MapSuite.VehicleTracking
{
    public class BooleanToBorderStyleConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value is bool)
            {
                bool result = (bool)value;
                Style checkedStyle = new Style(typeof(Border));
                checkedStyle.Setters.Add(new Setter(Border.BackgroundProperty, new SolidColorBrush(Color.FromArgb(51, 222, 81, 11))));
                checkedStyle.Setters.Add(new Setter(Border.BorderBrushProperty, new SolidColorBrush(Color.FromArgb(136, 136, 136, 136))));
                checkedStyle.Setters.Add(new Setter(Border.BorderThicknessProperty, new Thickness(1)));

                Style unCheckedStyle = new Style(typeof(Border));
                unCheckedStyle.Setters.Add(new Setter(Border.BackgroundProperty, new SolidColorBrush(Colors.Transparent)));
                unCheckedStyle.Setters.Add(new Setter(Border.BorderBrushProperty, new SolidColorBrush(Colors.Transparent)));
                unCheckedStyle.Setters.Add(new Setter(Border.BorderThicknessProperty, new Thickness(0)));

                return result ? checkedStyle : unCheckedStyle;
            }
            return null;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return null;
        }
    }
}
