﻿using ThinkGeo.MapSuite.SilverlightCore;
using ThinkGeo.MapSuite.VehicleTracking.ServiceReference;

namespace ThinkGeo.MapSuite.VehicleTracking
{
    public static class MapSuiteSampleHelper
    {
        public static int GetSpeedDuration(Vehicle vehicle)
        {
            int speedDuration = 0;
            double lastSpeed = vehicle.Location.Speed;
            foreach (Location location in vehicle.HistoryLocations)
            {
                if (location.Speed == lastSpeed)
                {
                    speedDuration++;
                }
                else
                {
                    break;
                }
            }

            return speedDuration;
        }

        /// <summary>
        /// If the Vehicle's speed is not 0 in the passed 4 minutes, we say it is in Motion. 
        /// </summary>
        /// <returns>State of current vehicle.</returns>
        public static string GetCurrentState(Vehicle vehicle)
        {
            string result = "Idle";// "In Motion";

            if (vehicle.Location.Speed != 0)
            {
                result = "In Motion";
            }
            else
            {
                int locationIndex = 0;
                foreach (Location historyLocation in vehicle.HistoryLocations)
                {
                    if (locationIndex > 3)
                    {
                        break;
                    }
                    if (historyLocation.Speed != 0)
                    {
                        result = "In Motion";
                        break;
                    }
                    locationIndex++;
                }
            }
            return result;
        }

        public static PointShape GetLocationPointShape(Location location)
        {
            return new PointShape(location.Longitude, location.Latitude);
        }
    }
}
