﻿using System.Collections.ObjectModel;
using System.Linq;

namespace ThinkGeo.MapSuite.VehicleTracking
{
    public class VehicleTrackingViewModel : ViewModelBase
    {
        private string defaultOverlayName;
        private UnitSystem selectedUnitSystem;
        private Collection<string> overlayNames;
        private Collection<UnitSystem> unitSystems;
        private ObservableCollection<VehicleViewModel> vehicles;

        public VehicleTrackingViewModel()
        {
            overlayNames = new Collection<string>();
            vehicles = new ObservableCollection<VehicleViewModel>();
            unitSystems = new Collection<UnitSystem> { UnitSystem.Imperial, UnitSystem.Metric };
            selectedUnitSystem = unitSystems[0];
        }

        public ObservableCollection<VehicleViewModel> Vehicles
        {
            get { return vehicles; }
        }

        public Collection<UnitSystem> UnitSystems
        {
            get { return unitSystems; }
        }

        public UnitSystem SelectedUnitSystem
        {
            get { return selectedUnitSystem; }
            set { selectedUnitSystem = value; }
        }

        public Collection<string> OverlayNames
        {
            get { return overlayNames; }
        }

        public string DefaultOverlayName
        {
            get { return string.IsNullOrEmpty(defaultOverlayName) ? overlayNames.FirstOrDefault() : defaultOverlayName; }
            set { defaultOverlayName = value; }
        }
    }

    public enum UnitSystem
    {
        Imperial = 0,
        Metric = 1,
    }
}
