﻿using System.Globalization;
using ThinkGeo.MapSuite.VehicleTracking.ServiceReference;

namespace ThinkGeo.MapSuite.VehicleTracking
{
    public class VehicleViewModel : ViewModelBase
    {
        private string area;
        private string speed;
        private string status;
        private string iconUri;
        private string duration;
        private string ownerName;
        private Vehicle vehicle;

        public VehicleViewModel()
            : this(null)
        { }

        public VehicleViewModel(Vehicle vehicle)
        {
            ownerName = vehicle.VehicleName;
            iconUri = "Image/" + vehicle.VehicleIconVirtualPath;
            Vehicle = vehicle;

            Load();
        }

        public Vehicle Vehicle
        {
            get { return vehicle; }
            set { vehicle = value; }
        }

        public void Load()
        {
            Status = MapSuiteSampleHelper.GetCurrentState(vehicle);
            Speed = vehicle.Location.Speed.ToString(CultureInfo.InvariantCulture) + " mph";
            Duration = MapSuiteSampleHelper.GetSpeedDuration(vehicle).ToString(CultureInfo.InvariantCulture) + " min";
        }

        public string Status
        {
            get { return status; }
            set
            {
                status = value;
                RaisePropertyChanged(() => Status);
            }
        }

        public string IconUri
        {
            get { return iconUri; }
            set
            {
                iconUri = value;
                RaisePropertyChanged(() => IconUri);
            }
        }

        public string Area
        {
            get { return area; }
            set
            {
                area = value;
                RaisePropertyChanged(() => Area);
            }
        }

        public string OwnerName
        {
            get { return ownerName; }
            set
            {
                ownerName = value;
                RaisePropertyChanged(() => OwnerName);
            }
        }


        public string Speed
        {
            get { return speed; }
            set
            {
                speed = value;
                RaisePropertyChanged(() => Speed);
            }
        }

        public string Duration
        {
            get { return duration; }
            set
            {
                duration = value;
                RaisePropertyChanged(() => Duration);
            }
        }
    }
}
